/////////////////////////////////////////////////////////////////////////////
//
//	$Header: /WinArena/Types.h 2     12/30/05 1:15a Lee $
//
//	File: Types.h
//
//
/////////////////////////////////////////////////////////////////////////////


#pragma once



enum DisplayMode_t
{
	Display_Automap,
	Display_Character,
	Display_ControlPanel,
	Display_Game,
	Display_Inventory,
	Display_Journal,
	Display_LoadSave,
	Display_SpellBook,
	Display_SpellPage,
};


enum PauseState_t
{
	Pause_NotPaused,
	Pause_SelectSpell,
	Pause_SelectItem,
};


enum AttackState_t
{
	Attack_Off,
	Attack_Idle,			// base 30
	Attack_Thrust,			// base 25
	Attack_Chop,			// base  0
	Attack_DownToRight,		// base 20
	Attack_LeftToRight,		// base 15
	Attack_DownToLeft,		// base  5
	Attack_RightToLeft		// base 10
};


enum CastingSpell_t
{
	Casting_Nothing,
	Casting_Acid,
	Casting_Fire,
	Casting_Ice,
	Casting_Magic,
	Casting_Shock,
	Casting_Smoke
};


enum TextureID_t
{
	Texture_NULL,
	Texture_Door,
	Texture_Gate,
	Texture_BlueRug,
	Texture_Cabinet,
	Texture_Marble,
	Texture_GlassCrown,
	Texture_GlassDragon,
	Texture_GlassHand,
	Texture_GlassSword,
	Texture_TrenchCeiling,
	Texture_Wall,
	Texture_GargoyleFace,
	Texture_WoodPlank,
	Texture_Abyss,
	Texture_Mural1,
	Texture_Mural2,
	Texture_Mural3,
	Texture_HUD,
	Texture_Pointer,
	Texture_CompassBorder,
	Texture_CompassLines,
	Texture_Automap,
	Texture_ControlPanel,
	Texture_Journal,
	Texture_LoadSave,
	Texture_SpellBook,
	Texture_SpellPage,
	Texture_ArraySize
};



enum AnimationName_t
{
	Animation_Bartender,
	Animation_Begger,
	Animation_Brazier,
	Animation_Candle,
	Animation_ChaosArrow,
	Animation_ChaosPillar,
	Animation_ChaosStone,
	Animation_CrystalBall,
	Animation_CrystalStaff,
	Animation_DarkAltar,
	Animation_Dragonling,
	Animation_Fireplace,
	Animation_FireGem,
	Animation_FireBreather,
	Animation_FirePitCauldron,
	Animation_FirePitCook,
	Animation_Fishbowl,
	Animation_Guard1,
	Animation_Guard2,
	Animation_Guard3,
	Animation_Guard4,
	Animation_Guard5,
	Animation_GuardDeath,
	Animation_GuardSingle1,
	Animation_GuardSingle2,
	Animation_GuardPair1,
	Animation_GuardPair2,
	Animation_GuardTalk1,
	Animation_GuardTalk2,
	Animation_GuardRender,
	Animation_Hoker1,
	Animation_Hoker2,
	Animation_Hoker3,
	Animation_HokerPushups,
	Animation_Jester,
	Animation_ManFlaggon,
	Animation_ManNodding,
	Animation_ManTalking,
	Animation_ManFarmer,
	Animation_MerchantTable,
	Animation_MerchantBooth,
	Animation_Moon1,
	Animation_Moon2,
	Animation_Musician1,
	Animation_Musician2,
	Animation_StoneLamp,
	Animation_Streetlight,
	Animation_StreetlightSnowy,
	Animation_FountainDragon,
	Animation_FountainNormal,
	Animation_FountainLion,
	Animation_Priest1,
	Animation_Priest2,
	Animation_Puddle,
	Animation_Rat,
	Animation_ShadyThug,
	Animation_SkullCandle,
	Animation_Smith,
	Animation_SnakeCharmer,
	Animation_TorchPost,
	Animation_Vendor,
	Animation_VolcanoSmall,
	Animation_VolcanoDagothUr,
	Animation_VolcanoLarge,
	Animation_WaterColumn,
	Animation_WaterColumnBroken,
	Animation_Wizard,
	Animation_WomanLeather,
	Animation_WomanTankard,
	Animation_WomanHaughty,
	Animation_WomanBikini,
	Animation_Seaweed,
	Animation_WaterStatue1,
	Animation_WaterStatue2,

	Animation_BloodSpurt,
	Animation_AcidBurstLarge,
	Animation_AcidBurstSmall,
	Animation_AcidBulletLarge,
	Animation_AcidBulletSmall,
	Animation_FireBurstLarge,
	Animation_FireBurstSmall,
	Animation_FireBulletLarge,
	Animation_FireBulletSmall,
	Animation_GasBurstLarge,
	Animation_GasBurstSmall,
	Animation_GasBulletLarge,
	Animation_GasBulletSmall,
	Animation_IceBurstLarge,
	Animation_IceBurstSmall,
	Animation_IceBulletLarge,
	Animation_IceBulletSmall,
	Animation_MagicBurstLarge,
	Animation_MagicBurstSmall,
	Animation_MagicBulletLarge,
	Animation_MagicBulletSmall,
	Animation_ShockBurstLarge,
	Animation_ShockBurstSmall,
	Animation_ShockBulletLarge,
	Animation_ShockBulletSmall,
	Animation_ArraySize
};


enum SoundID_t
{
	Sound_ArrowFire,
	Sound_ArrowHit,
	Sound_Background,
	Sound_Bash,
	Sound_Birds1,
	Sound_Birds2,
	Sound_BodyFall,
	Sound_Burst,
	Sound_Clank,
	Sound_Clicks,
	Sound_CloseDoor,
	Sound_DeepChoir,
	Sound_DirtLeft,
	Sound_DirtRight,
	Sound_Drip1,
	Sound_Drip2,
	Sound_Drums,
	Sound_Eerie,
	Sound_EHit,
	Sound_Explode,
	Sound_Fanfare1,
	Sound_Fanfare2,
	Sound_FemaleDie,
	Sound_FireDaemon,
	Sound_Ghost,
	Sound_Ghoul,
	Sound_Grind,
	Sound_Growl0,
	Sound_Growl1,
	Sound_Growl2,
	Sound_Halt,
	Sound_HellHound,
	Sound_HighChoir,
	Sound_Homonculous,
	Sound_HumEerie,
	Sound_IceGolem,
	Sound_IronGolem,
	Sound_Lich,
	Sound_Lizard,
	Sound_Lock,
	Sound_MaleDie,
	Sound_Medusa,
	Sound_Minotaur,
	Sound_Monster,
	Sound_Moon,
	Sound_MudStepLeft,
	Sound_MudStepRight,
	Sound_NHit,
	Sound_OpenAlt,
	Sound_OpenDoor,
	Sound_Orc,
	Sound_Portcullis,
	Sound_Rat,
	Sound_Scream1,
	Sound_Scream2,
	Sound_Skeleton,
	Sound_SlowBall,
	Sound_Snarl,
	Sound_SnowLeft,
	Sound_SnowRight,
	Sound_Splash,
	Sound_Squish,
	Sound_StoneGolem,
	Sound_StopThief,
	Sound_Swimming,
	Sound_Swish,
	Sound_Thunder,
	Sound_Troll,
	Sound_UHit,
	Sound_Umph,
	Sound_Vampire,
	Sound_Whine,
	Sound_Wind,
	Sound_Wolf,
	Sound_Wraith,
	Sound_Zombie,
	Sound_ArraySize
};


enum CellFlags_t
{
	CellFlag_Solid			= 0x00000001,
	CellFlag_Raised			= 0x00000002,		// raise floor, bed, table...
	CellFlag_HasFloor		= 0x00000004,
	CellFlag_HasCeiling		= 0x00000008,
	CellFlag_Door			= 0x00000010,
	CellFlag_SecretDoor		= 0x00000020,
	CellFlag_TriggerMask	= 0x00000030,		// if any of these flags it set, the cell has a trigger
};


struct CellNode_t
{
	DWORD Flags;
	DWORD Volume;
	DWORD Floor;
	DWORD Ceiling;
	DWORD Trigger;
};


enum TriggerFlags_t
{
	TriggerFlag_Open		= 0x00000001,		// only valid for doors
	TriggerFlag_Opening		= 0x00000002,
	TriggerFlag_Closing		= 0x00000004,
	TriggerFlag_StateMask	= 0x0000000F,
};


struct Trigger_t
{
	DWORD Flags;
	DWORD East;
	DWORD South;
	DWORD BaseTime;
};


struct Sprite_t
{
	long  Position[3];
	DWORD TextureID;
	bool  Animated;
	DWORD Brightness;		// non-zero for light-casting sprites
	DWORD BaseTime;			// base time in milliseconds used for animation cycle
	long  Width;
	long  Height;
	char  Name[32];
};


struct Projectile_t
{
	long  Position[3];
	long  DeltaX;
	long  DeltaZ;
	long  Brightness;
	DWORD BulletID;
	DWORD ExplodeID;
	DWORD ExplodeSound;
	DWORD BaseTime;
	DWORD Active;			// 0 == inactive, 1 == flying, 2 == exploding
};


struct LightSource_t
{
	long  Position[3];
	long  BaseBrightness;
	long  CurrentBrightness;
	DWORD FlickerTime;
	DWORD FlickerDuration;
};


enum CritterFlag_t
{
	CritterFlag_Translucent	= 0x00000001
};


struct CritterInfo_t
{
	char* FileName;
	char* DisplayName;
	DWORD Flags;
	long  Center[6];		// pixel offset from left of image to centerline of critter
	long  Vertical[6];		// vertical displacement
	long  Scale[6];
	DWORD VocalizeID;
};


struct Critter_t
{
	long  Position[3];
	DWORD CritterID;
	long  Direction;
	DWORD State;			// 0 = unused, 1 = dead, 
	DWORD BaseTime;
	DWORD VocalizeTime;
	char  Name[32];
};


struct Triangle_t
{
	Triangle_t* pNext;
	Vertex_t    Corners[3];
};


struct SoundClip_t
{
	DWORD  SoundID;
	DWORD  SampleCount;
	short* pSamples;
};


struct SoundFile_t
{
	char*     Name;
	SoundID_t ID;
	DWORD     FilterLength;
	DWORD     TrimStart;		// some clip have garbage at the beginning -- zero-out this many samples
};


struct AnimInfo_t
{
	AnimationName_t ID;
	char* Name;
	long  Scale;
	DWORD LoopDuration;			// milliseconds required to cycle through animation sequence
	DWORD Brightness;			// 0-100, where 0 == sprite/anim does not emit light
};


struct SpellInfo_t
{
	char* Name;
	DWORD AnimationID;
	DWORD BulletID;
	DWORD ExplodeID;
	DWORD ExplodeSound;
	DWORD Special;
};


struct Character_t
{
	char Name[32];
	char Race[32];
	char Class[32];
	long Strength;
	long Intelligence;
	long Willpower;
	long Agility;
	long Speed;
	long Endurance;
	long Personality;
	long Luck;

	long HealthCurrent;
	long HealthMaximum;
	long FatigueMaximum;
	long FatigueCurrent;
	long Gold;
	long Experience;
	long Level;

	long DamageModifier;
	long SpellPointsMaximum;
	long SpellPointsCurrent;
	long MagicDefence;
	long ToHitModifier;
	long HealthModifier;
	long CharismaModifier;
	long MaxWeight;
	long ArmorClassModifier;
	long HealModifier;
};

